/*
 * Created on 13-jun-2005
 */
package free.chanante.retrospector.guiones;

import free.chanante.retrospector.Personaje;
import free.chanante.retrospector.exceptions.HostiaFina;
import free.chanante.retrospector.exceptions.PuetazoRapido;

/**
 * El episodio del gaan ... que lo engaan ...
 * @author SeS
 */
public class EpisodioDelGaan implements Guion {

	/**
	 * Gran presentacion advirtiendonos de que vamos a ver a un gaanaaaaaaaaaaaaaazo
	 */
	public void presentacionDelRepeinao() {
		System.out.println("La belleza est en el interior, eso lo sabe todo el mundo. Pero veremos que le pasa a un gaan, que lo engaaaan");
	}

	/* (non-Javadoc)
	 * @see free.chanante.retrospector.Guion#despedidaDelRepeinao()
	 */
	public void despedidaDelRepeinao() {
		System.out.println("Ms le hubiese valido al gaan quedarse con la jeta que tena y no andar de cambios.");
		System.out.println("Contentaros con lo que os da dios y no os quejis.");
		System.out.println("Hasta luego amigos, adios.");
	}

	/* (non-Javadoc)
	 * @see free.chanante.retrospector.Guion#accion()
	 */
	public void accion() {
		Gaan gaan = new Gaan();
		gaan.intentandoLigar();
		Tangador tangador = new Tangador();
		tangador.divisa(gaan);
		tangador.invita(gaan);
		tangador.proponeNegocio(gaan);
		gaan.noLeMolaElNegocio();
		tangador.pagaUnPrecio(25);
		gaan.aceptaElNegocio();
		tangador.advierte(gaan);
		System.out.println("Sabado por la tarde ...");
		System.out.println("Bata de pana ...");
		System.out.println("Emocin ...");
		Medico medico = new Medico();
		Personaje gaanOperado = gaan.operado(medico);
		System.out.println("Nueva cara, nuevos problemas para el ganico ...");
		if (gaanOperado instanceof Tangador) {
			Tangador gaanConOtroJeto = (Tangador) gaanOperado;
			Maton maton = new Maton();
			gaanConOtroJeto.noLeMolaElPiso();
			boolean seHaTiradoALasCajasVacias = false; 
			try {
				maton.seSincera(gaanConOtroJeto);
			} catch (HostiaFina hostia) {
				gaanConOtroJeto.seTiraALasCajasVacias();
				seHaTiradoALasCajasVacias = true;
			}
			try {
				maton.leMideElLomo(gaanConOtroJeto, seHaTiradoALasCajasVacias);
			} catch (PuetazoRapido puetazoRapido) {}
		}		
		
	}


	/* (non-Javadoc)
	 * @see free.chanante.retrospector.Guion#colofon()
	 */
	public void colofon() {
		Tangador gaanOperadoYCurtidoAPalos = new Tangador("Gaan operado y curtido a palos");
		System.out.println(gaanOperadoYCurtidoAPalos.getNombre() + ": Alguna le he dao yo");			
	}
	
	
	/* Personajillos */
	
	/**
	 * Ese personaje tan carismtico
	 * @author SeS
	 */
	private class Gaan implements Personaje {
		
		private String nombre;
		public String mote = "gaan";
		public String moteAcentuado = "gaaaaaaaaanazo";

		/**
		 * Aparicin del Gaan 
		 */
		public Gaan() {
			this("Gaan");
			System.out.println("Aparece el " + this.mote);
		}

		/**
		 * Aparicin del Gaan personalizado
		 * @param nombre
		 */
		public Gaan(String nombre) {
			this.nombre = nombre;
		}

		/**
		 * Ni el Travolta, vamos ...
		 */
		public void intentandoLigar() {
			System.out.println(this.getNombre() + ": A ver zagalas, esto que no es piel, que es polipiel me ha costado 5 Euros en modas barcelona");
		}

		/**
		 * Y se lo dice cantando
		 */
		public void noLeMolaElNegocio() {
			System.out.println("El " + this.mote + " se pone a cantar");			
			System.out.println(this.getNombre() + ": Estoy muy orgulloso");			
			System.out.println(this.getNombre() + ": Con lo que ma dao dios");			
			System.out.println(this.getNombre() + ": Soy un tio acoooooojonante");			
			System.out.println(this.getNombre() + ": Se lo digo cantando");			
		}
		
		/**
		 * No faltan putos, faltan buenos financistas
		 */
		public void aceptaElNegocio() {
			System.out.println(this.getNombre() + ": Vale, pues lo acepto. Ah voy.");						
		}		

		/**
		 * El gaan se opera.
		 * @param medico ser el doctor Visconti?
		 */
		public Personaje operado(Medico medico) {
			System.out.println(medico.getNombre() + ": Gires y se mira en el espejo");
			System.out.println(this.getNombre() + ": No, me miro en la puera madera");
			Tangador enjendro = new Tangador("Gaan Operado");
			System.out.println(enjendro.getNombre() + ": Molo");
			return enjendro;			
		}
		
		/* (non-Javadoc)
		 * @see free.chanante.retrospector.Personaje#getNombre()
		 */
		public String getNombre() {
			return this.nombre;
		}
		
	}
	
	/**
	 * El aprovechado
	 * @author SeS
	 */
	private class Tangador implements Personaje {

		public String nombre;
		
		/**
		 * Aparicin del tangador
		 */
		public Tangador() {
			this("Tangador");
		}

		/**
		 * Aparicin del tangador personalizado
		 * @param nombre
		 */
		public Tangador(String nombre) {
			this.nombre = nombre;
			System.out.println("Aparece el " + this.nombre);			
		}

		/**
		 * Contacto visual
		 * @param gaan la victima
		 */
		public void divisa(Gaan gaan) {
			System.out.println(this.getNombre() + ": Madre mia ... estoy viendo un " + gaan.moteAcentuado);			
			System.out.println(this.getNombre() + ": A este le voy a proponer un negocio que no va a poder desechaaaaaar");			
		}
		
		/**
		 * Invitacin
		 * @param gaan el invitado
		 */
		public void invita(Gaan gaan) {
			System.out.println(this.getNombre() + ": Esta usted serio como un badil");			
			System.out.println(gaan.getNombre() + ": Es que no me gusta que me llamen a estas horas");			
			System.out.println(this.getNombre() + ": Pase por aqui que le voy a contar una cosa");			
			System.out.println(this.getNombre() + ": Voy a ir al grano porque es usted un " + gaan.mote);			
			System.out.println(gaan.getNombre() + ": " + gaan.mote);			
			System.out.println(gaan.getNombre() + ": Cmo " + gaan.mote + "?");			
			System.out.println(this.getNombre() + ": S, es usted un " + gaan.moteAcentuado + " eso lo sabe todo el mundo");			
			
		}

		/**
		 * Cuidado gaan, que te la meten doblada.
		 * @param gaan
		 */
		public void proponeNegocio(Gaan gaan) {
			System.out.println(this.getNombre() + ": Le ofrezo que se cambie su cara por la ma en dermosttica");					
		}
	
		/**
		 * Es hora de pagar un precio.
		 * @param precio precio a pagar en Euros.
		 */
		public void pagaUnPrecio(int precio) {
			System.out.println(this.getNombre() + ": Aqu van, " + precio + " Euros.");			
		}

		/**
		 * El tangador no quiere que se la metan dobl.
		 * @param gaan
		 */
		public void advierte(Gaan gaan) {
			System.out.println(this.getNombre() + ": Me tienes que jurar, eh!, por las Hoces del Gabriel. Que te vas a operar.");			
			System.out.println(this.getNombre() + ": En dermosttica el sabado, no quiero jugarretas, no quiero que me la metas dobl.");			
			System.out.println(gaan.getNombre() + ": En dermosteeeetica. S, ah me voy a operar, el sabado.");						
		}

		/**
		 * El gaanico aspira a algo ms
		 */
		public void noLeMolaElPiso() {
			System.out.println(this.getNombre() + ": Bueno, ya me he hecho una idea");						
			System.out.println(this.getNombre() + ": Vamos por partes pa que se me entienda bien");						
			System.out.println(this.getNombre() + ": Esto no es luminoso, esto es como un ojete");						
			System.out.println(this.getNombre() + ": Esta sucsimo y no son 200 metros cuadraos ni de coa");						
		}

		/**
		 * 
		 */
		public void seTiraALasCajasVacias() {
			System.out.println(this.getNombre() + ": Ohhhhhh! Joder, no me lo esperaba");						
		}
		
				
		/* (non-Javadoc)
		 * @see free.chanante.retrospector.Personaje#getNombre()
		 */
		public String getNombre() {
			return nombre;
		}

		
		
		
	}
	
	/**
	 * Este es el doctor Visconti como mnimo.
	 * @author SeS
	 */
	private class Medico implements Personaje {

		/* (non-Javadoc)
		 * @see free.chanante.retrospector.Personaje#getNombre()
		 */
		public String getNombre() {
			return "Mdico";
		}
		
	}
	
	/**
	 * Con lo poca cosa que parece ...
	 * @author SeS
	 */
	private class Maton implements Personaje {

		public String nombre;
		
		/**
		 * Aparicin del tangador
		 */
		public Maton() {
			this("Maton");
		}

		/**
		 * Aparicin del tangador personalizado
		 * @param nombre
		 */
		public Maton(String nombre) {
			this.nombre = nombre;
			System.out.println("Aparece el " + this.nombre);			
		}
		
		/**
		 * Y de que forma.
		 * @throws HostiaFina
		 */
		public void seSincera(Tangador gaan) throws HostiaFina {
			
			System.out.println(this.getNombre() + ": Bueno, muy bien. Entonces como usted ha sido muy franco, le voy a decir la verdad");						
			System.out.println(this.getNombre() + ": Le he traido aqu para una cosa ...");						
			System.out.println(this.getNombre() + ": Aqu hay un arbol");						
			System.out.println(this.getNombre() + ": Aqu hay un ro");						
			System.out.println(this.getNombre() + ": Se cae el arbol");						
			System.out.println(this.getNombre() + ": Salpica el ro");						
			System.out.println(this.getNombre() + ": Que le den por culo");						
			System.out.println(" * tic *");						
			System.out.println(this.getNombre() + ": Que le ha parecido? Soy un buen poeta?"); 
			System.out.println(gaan.getNombre() + ": Si hombre es usted el puto Diego Manrique"); 
			System.out.println(gaan.getNombre() + ": Ala! Vayase por donde ha venido"); 
			System.out.println(this.getNombre() + ": Bueno, pues me voy ...");						
			throw new HostiaFina();
			
		}

		/**
		 * Por gaan
		 * @param gaanOperado
		 * @param seHaTiradoALasCajasVacias
		 * @throws PuetazoRapido
		 */
		public void leMideElLomo(Tangador gaanOperado, boolean seHaTiradoALasCajasVacias) throws PuetazoRapido {
			if (seHaTiradoALasCajasVacias) {
				System.out.println(this.getNombre() + ": Y no te tires a las cajas vacias!"); 
			}
			System.out.println(this.getNombre() + ": Me engaaste con lo del nscalo"); 
			System.out.println(this.getNombre() + ": Me engaaste con lo de las camisetas de nylon"); 
			throw new PuetazoRapido();
		}

		
		/* (non-Javadoc)
		 * @see free.chanante.retrospector.Personaje#getNombre()
		 */
		public String getNombre() {
			return this.nombre;
		}
		
	}

}
